
#include "../timer/timer.hpp"
#include "../timer/timer.ipp"
#include "../timer/looper.hpp"
#include "../timer/looper.ipp"

#include <iostream>


inline double do_test( matt::timer& t )
{
	t.restart();

	std::vector<int> fred;
	fred.resize(1000);

	return t.elapsed();
}

inline void simple(  )
{

	std::vector<int> fred;
	fred.resize(1000);

}

int main()
{
	//SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_TIME_CRITICAL);
	SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_NORMAL);

	Sleep(1000);
	//matt::timer t(2.09);
    matt::timer t(3.19134);
    // matt::timer t;
	//std::cout << "processor speed guess = " << t.estimate_frequency(181) << "\n";

	double now;

	std::cout << "---------------------------------------------------------------------\n";
	t.restart();
	now = t.elapsed();


	std::cout << "quick time before overhead estimate= " << matt::time_text(now) << "\n";
	t.restart();
	now = t.elapsed();

	std::cout << "quick time before overhead estimate= " << matt::time_text(now) << "\n";
	t.restart();
	now = t.elapsed();

	std::cout << "quick time before overhead estimate= " << matt::time_text(now) << "\n";

	std::cout << "overhead estimate = " << matt::time_text(t.minimum_overhead_estimator()) << "\n";

	t.restart();
	now = t.elapsed();

	std::cout << "quick time after overhead estimate= " << matt::time_text(now) << "\n";
	t.restart();
	now = t.elapsed();

	std::cout << "quick time after overhead estimate= " << matt::time_text(now) << "\n";
	t.restart();
	now = t.elapsed();

	std::cout << "quick time after overhead estimate= " << matt::time_text(now) << "\n";

	matt::looper loopy;
	//std::cout << "boost function overhead estimate = " << matt::time_text(loopy.estimate_boost_function_overhead()) << "\n";
	      
	loopy.do_intrusive(&do_test, 1001);
	loopy.do_timings(&simple, 1001);
	system("pause");

	return 0;
}
